#! /usr/bin/python3.2
"""
 * Copyright (C) 2013   Christian Eppler
 * File:                src/main.py
 * Project              copydiff
 * Title:               Start file 
 * Author:              Christian Eppler
 * E-Mail:              weblooker@silentchris.de
 * Created on:          2.05.2013
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, see <http://www.gnu.org/licenses/>.
"""

import sys
import os
from subprocess import call

from copydiff import Parseinput as parse
from copydiff import File_manager as file_m

def copydiff():
    buf = ""
    buf2 = ""
    time = ""
    TMPFOLDER = "/tmp/diff"
    TMPFILE = "/tmp/diff.txt"
      
    time = "%s" % (parse.args.time)
    
    if(parse.args.comma):
        time= time.replace(".",",")
    else:
        time= time.replace(",",".")
        
    buf2 = "find %s -mtime %s 2>/dev/null 1> %s" % (parse.args.path,time,TMPFILE)
    
    if(parse.args.show):
       print(buf2)
       os.system(buf2)

       file = file_m.File_manager()        
       file.setfile(TMPFILE)
       file.open()
        
       while file.nextline():
           line = file.getline()
           if line.count("/proc") + line.count("/sys") +line.count("/tmp") +line.count("/dev") +line.count("/var/log") +line.count("/run") +line.count("/var/cache"):
               continue
           else:
               file.printline()      
    else:
        print(buf2)
        os.system(buf2)

        file = file_m.File_manager()        
        file.setfile(TMPFILE)
        file.open()
        
        buf = "rm -rf %s/*" % (TMPFOLDER)
        os.system(buf)
        
        buf = "mkdir -p %s" % (TMPFOLDER)
        os.system(buf)
                
        while file.nextline():
            line = file.getline()
            if line.count("/proc") + line.count("/sys") +line.count("/tmp") +line.count("/dev") +line.count("/var/log") +line.count("/run") +line.count("/var/cache"):
                continue
            else:
                file.printline()

                buf = "mkdir -p %s/%s" % (TMPFOLDER,line)
                os.system(buf)
                
                buf = "rm -rf %s/%s" % (TMPFOLDER,line)
                os.system(buf)
                
                buf = "cp %s %s/%s" % (line.replace("\n",""),TMPFOLDER,line)
                os.system(buf)      
    
copydiff()